package thKaguyaMod;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;
import cpw.mods.fml.common.network.IGuiHandler;

public class GuiHandler implements IGuiHandler
{
	
	@Override
	public Object getClientGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z)
	{
		if (ID == mod_thKaguya.guiDanmakuCraftingID )
		{
			return new GuiDanmakuCrafting(player, world, x, y, z);
		}
		else if(ID == mod_thKaguya.guiDanmakuCraftingLaserID)
		{
			return new GuiDanmakuCraftingLaser(player, world, x, y, z);
		}
 
		return null;
	}
 
	@Override
	public Object getServerGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z)
	{
		if (ID == mod_thKaguya.guiDanmakuCraftingID )
		{
			return new ContainerDanmakuCrafting(player.inventory, world, x, y, z);
		}
		else if(ID == mod_thKaguya.guiDanmakuCraftingLaserID)
		{
			return new ContainerDanmakuCraftingLaser(player.inventory, world, x, y, z);
		}
 
		return null;
	}
}
